#include "AneuMeshLoader.h"
#include <fstream>
#include "Exceptions.h"

void AneuMeshLoader::loadMesh(const std::string& str) {
	std::ifstream file(str);

	if (!file) {
		throw FileIsNotFound(str);
	}

	int n, k, c;
	file >> n >> k;
    // node.reserve(k) ДОЛЖЕН БЫТЬ ВЫЗВАН ОДИН РАЗ И ПЕРЕД ЦИКЛОМ,
    // ЗАЧЕМ КАЖДЫЙ РАЗ В ЦИКЛЕ ВЫЗЫВАТЬ?
	for (int i = 1; i <= n; i++) {
		Node a;
		a.ID_Node = i;
		file >> a.Coordinate[0] >> a.Coordinate[1] >> a.Coordinate[2];
		a.flag = true;
		node.push_back(a);
		node.reserve(k);
        node.push_back(std::move(a));
	}

	file >> n >> k;
	for (int i = 1; i <= n; i++) {
		FiniteElement a;
		a.ID_FiniteElement = i;
		file >> a.ID_Material;
		for (int j = 1; j <= k; j++) {
			file >> c;
			a.ID_Nodes.push_back(c);
		}
        // ПЕРЕД ЦИКЛОМ
		finite_el.reserve(k);
		finite_el.push_back(std::move(a));
	}

	file >> n >> k;
	for (int i = 1; i <= n; i++) {
		BoundaryFiniteElement a;
		a.ID_Element = i;
		file >> a.ID_Boundary;
		for (int j = 1; j <= k; j++) {
			file >> c;
			a.ID_Nodes.push_back(c);
		}
        // ПЕРЕД ЦИКЛОМ
        boundary_el.reserve(k);
        boundary_el.push_back(std::move(a));
	}
	file.close();
}
